hint="run before: remote/runit-configure nginx -- $site"
assert "sudo test -f /etc/nginx/x509.d/\"$site\"/key.pem" hint
assert "sudo test -f ~wiki-$site/etc/ssh/id_rsa" hint

sudo install -m 664 -o www -g www \
 "$tool"/var/pub/x509/vie.cyclocoop.org/crt+ca.pem \
 /etc/nginx/x509.d/"$site"/crt.pem

"$tool"/local/apt-get-install ikiwiki \
 xapian-omega \
 libsearch-xapian-perl \
 libdigest-sha-perl \
 libhtml-scrubber-perl

"$tool"/local/adduser fcgi-"$site" \
 --disabled-login \
 --disabled-password \
 --group \
 --home /home/cyclo/var/ikiwiki/'"'$site'"' \
 --shell /bin/false \
 --system
"$tool"/local/adduser www-"$site" \
 --disabled-login \
 --disabled-password \
 --group \
 --home /home/www/data/"$site" \
 --shell /bin/false \
 --system
sudo adduser fcgi-"$site" www-"$site"
sudo adduser fcgi-"$site" wiki-"$site"
#sudo adduser www-"$site"-tls www-"$site"
sudo install -d -m 2770 -o wiki-"$site" -g wiki-"$site" \
 /home/cyclo/var/ikiwiki/"$site"
sudo install -d -m 3771 -o git -g git \
 /home/git/hooks/cyclo
sudo install -d -m 750 -o wiki-"$site" -g git \
 /home/git/hooks/cyclo/"$site"
sudo install -m 771 -o git -g git /dev/stdin \
 /home/git/data/cyclovie.git/hooks/post-update <<-EOF
	#!/bin/sh -efux
	
	# The cd below is why we must use this script.
	# The current directory may not be accessible
	# by the user running the ikiwiki.
	# the execution of the ikiwiki wrapper would fail with :
	# "E: Failed to change to directory '...': Permission denied"
	cd /
	
	exec /home/git/hooks/cyclo/$site/post-update.ikiwiki
	EOF

if sudo test -d /home/cyclo/var/ikiwiki/"$site"/src/.git
 then sudo -u wiki-"$site" sh -$-c ' \
		cd /home/cyclo/var/ikiwiki/'"'$site'"'/src &&
		git pull -v &&
		git submodule update --recursive --init'
 else
	sudo -u wiki-"$site" sh -$-c ' \
		umask 007 &&
		git clone \
		 git@localhost:cyclovie \
		 /home/cyclo/var/ikiwiki/'"'$site'"'/src &&
		cd /home/cyclo/var/ikiwiki/'"'$site'"'/src &&
		git config core.sharedRepository group &&
		git submodule update --recursive --init
	 '
 fi

sudo adduser wiki-"$site" www-"$site"
sudo install -d -m 2770 -o wiki-"$site" -g fcgi-"$site" \
 /home/www/data/"$site"/cgi
cd /
sudo -u wiki-"$site" ikiwiki \
 --verbose \
 --setup /home/cyclo/var/ikiwiki/"$site"/src/ikiwiki.setup \
 --refresh \
 --wrappers
sudo chown fcgi-"$site":wiki-"$site" \
 /home/git/hooks/cyclo/"$site"/post-update.ikiwiki
sudo chmod 6755 \
 /home/git/hooks/cyclo/"$site"/post-update.ikiwiki
sudo chmod g+w \
 /home/cyclo/var/ikiwiki/"$site"/src/.ikiwiki \
 /home/cyclo/var/ikiwiki/"$site"/src/.ikiwiki/xapian/default

sudo cat /etc/gitweb/gitweb.conf - <<-EOF |
	\$export_ok = "cyclo-vie-export-ok";
	\$favicon = "/gitweb/static/git-favicon.png";
	\$home_link = "/";
	\$home_link_str = 'vie';
	\$home_text = "/etc/gitweb/cyclo.home_text.html";
	\$javascript = "/gitweb/static/gitweb.js";
	\$logo = "/gitweb/static/git-logo.png";
	\$my_uri = "/gitweb/";
	\$my_url = "/gitweb/";
	\$projects_list = "/etc/gitweb/cyclo-vie.projects.list";
	\$site_footer = "/etc/gitweb/cyclo.site_footer.html";
	\$site_header = "/etc/gitweb/cyclo.site_header.html";
	\$site_name = "vie.cyclocoop.org";
	@stylesheets = ("/gitweb/static/gitweb.css");#
	EOF
sudo install -m 640 -o root -g fcgi-gitweb /dev/stdin \
 /etc/gitweb/cyclo-vie.conf
sudo install -m 640 -o root -g fcgi-gitweb \
 "$tool"/etc/gitweb/cyclo.home_text.html \
        /etc/gitweb/cyclo.home_text.html
sudo install -m 640 -o root -g fcgi-gitweb /dev/stdin \
 /etc/gitweb/cyclo-vie.projects.list <<-EOF
	cyclovie.git
	EOF
